package org.jugvale.jbpm.workitemhandler;
import org.drools.core.process.instance.WorkItemHandler;
import org.kie.api.runtime.process.WorkItem;
import org.kie.api.runtime.process.WorkItemManager;

import com.twilio.Twilio;
import com.twilio.rest.api.v2010.account.Message;
import com.twilio.type.PhoneNumber;

import java.net.URI;
import java.net.URISyntaxException;

public class SMSWorkItemHandler implements WorkItemHandler {
	 public static final String ACCOUNT_SID = "XXXXXXXXXXXXXXX";
	 public static final String AUTH_TOKEN = "XXXXXXXXXXXXXXXX";
	 public static final String FROM = "###############";
	
		public void abortWorkItem(WorkItem wi, WorkItemManager wim) {
			System.out.println("Oh something went wrong");
			
		}

		public void executeWorkItem(WorkItem wi, WorkItemManager wim) {
			
			String to = (String)wi.getParameter("TO");
			String text = (String)wi.getParameter("TEXT");
			
			
			assert to != null: "to can't be null";
			assert text != null: "text cant be null";
			
		
				SendSMS(to,text);
		
			
			System.out.println("Message has been succesfully sent");
			System.out.println("To: "+to);
			System.out.println("From: "+FROM);
			System.out.println("Text: "+text);
			
			wim.completeWorkItem(wi.getId(), null);
		}
	
	public static void SendSMS(String to, String text)
	{
		 Twilio.init(ACCOUNT_SID, AUTH_TOKEN);
		
			Message message = Message
			            .creator(new PhoneNumber(to),  // to
			                     new PhoneNumber(FROM),  // from
			                     text)
			            .create();
	}
	
	
	public void SendSMS(String to, String text, String MediaURL)
	{
		 Twilio.init(ACCOUNT_SID, AUTH_TOKEN);
		 try {
			Message message = Message
			            .creator(new PhoneNumber("to"),  // to
			                     new PhoneNumber(FROM),  // from
			                     text)
			            .setMediaUrl(new URI(MediaURL))
			            .create();
		} catch (URISyntaxException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
